﻿# Autor:    Christian Claus
# Datum:    31. Januar 2014
#           Erstellt aus "Obj2x88i1.py" (fuer Aurora V1)
#           vom 23. August 2010
#
#   Einlesen der Datei "z88structure.obj", Herausschreiben der
#   von Z88 Aurora V2 lesbaren Datei "z88structure.txt"
#
#   29.03.2014:  Bug entfernt durch Hinzufügen der Zeilen 311/312
#
#   06.09.2015 erweitert:
#       Änderung des *.obj-Exports ab Blender 2.70:
#       Haken bei der Option "Write Normals" default gesetzt statt nicht gesetzt:
#           Das Skript kann jetzt die Datei "z88structure.obj"
#           unabhängig davon lesen, ob Normalen enthalten sind
#           oder nicht. Die ergänzten Stellen sind durch
#
#           #   ********
#           #   ********   gekennzeichnet !
#
#	29.12.2015:		Zwei "Zaehlfehler" korrigiert

from math import *
from tkinter import *

#   Ein- und Auslesedateien definieren

dateiEin = "z88structure.obj"
dateiAus = "z88structure.txt"

#
#   Elementtyp 23 -> Vierecke, Elementtyp 24 -> Dreiecke
#   falls die Datei z88structure.obj Dreick-Faces enthält,
#   wird ein Finite-Elemente-Modell ausschließlich aus
#   Dreiecken Typ 24 erstellt.
#   Sind keine Dreieck-Faces vorhanden, entsteht ein Finite-
#   Elemente-Modell aus Vierecken Typ 23
#

#   Erstes Öffnen der zu lesenden Datei, "Statistik"

typ = 23

dateie = open(dateiEin,"r")
vert = 0
face = 0
facefeld = {}

#   ******
wert1 = {}
wert2 = {}
#   ******

steuer = {}
feld = {}

while True:
    line = dateie.readline()

#   Abbruchbedingung für das Lesen

    if len(line) == 0:
        break

#   Vertices lesen, deren Anzahl feststellen

    wert = line.split(" ")
    if wert[0] == 'v':
        vert = vert + 1

#   Faces lesen, deren Anzahl und die unmittelbare Nachbarschaft
#   zweier Vertices feststellen

    if wert[0] == 'f':
        face = face + 1
        if len(wert) < 4:
            print("Achtung: da sind doch wieder Zwei-Ecke verbaut !!!")

#           len(wert) < 5   --> Dreiecke !

        elif len(wert) < 5:
            typ = 24

#           ******************
            for j in range(3):
                wert1[j+1] = wert[j+1].strip()
                wert2[j+1] = wert1[j+1].split("//")
            if len(wert1)>1:
                for k in range(3):
                    wert[k+1] = wert2[k+1][0]
            else:
                 for k in range(3):
                    wert[k+1] = wert2[k+1]
#           ******************

            for i in range(3):
                facefeld[face,(i+1)] = int(wert[(i+1)])
            steuer[face] = 3
            feld[max(facefeld[face,1],facefeld[face,2]),
                 min(facefeld[face,1],facefeld[face,2])] = 1
            feld[max(facefeld[face,2],facefeld[face,3]),
                 min(facefeld[face,2],facefeld[face,3])] = 1
            feld[max(facefeld[face,3],facefeld[face,1]),
                 min(facefeld[face,3],facefeld[face,1])] = 1

        else:

#           len(wert) = 5   --> Vierecke !

#           ******************
            for j in range(4):
                wert1[j+1] = wert[j+1].strip()
                wert2[j+1] = wert1[j+1].split("//")
            if len(wert1)>1:
                for k in range(4):
                    wert[k+1] = wert2[k+1][0]
            else:
                 for k in range(4):
                    wert[k+1] = wert2[k+1]
#           ******************

            for i in range(4):
                facefeld[face,(i+1)] = int(wert[(i+1)])
            steuer[face] = 4
            feld[max(facefeld[face,1],facefeld[face,2]),
                 min(facefeld[face,1],facefeld[face,2])] = 1
            feld[max(facefeld[face,2],facefeld[face,3]),
                 min(facefeld[face,2],facefeld[face,3])] = 1
            feld[max(facefeld[face,3],facefeld[face,1]),
                 min(facefeld[face,3],facefeld[face,1])] = 1
            feld[max(facefeld[face,3],facefeld[face,4]),
                 min(facefeld[face,3],facefeld[face,4])] = 1
            feld[max(facefeld[face,4],facefeld[face,1]),
                 min(facefeld[face,4],facefeld[face,1])] = 1
            feld[max(facefeld[face,1],facefeld[face,3]),
                 min(facefeld[face,1],facefeld[face,3])] = 1
            face = face + 1

dateie.close()
#
#   Falls z88structure.obj nur Viereck-Faces enthält,
#   wird ein Finite-Elemente-Modell nur aus Vierecken
#   erstellt. In diesem Fall wird die Datei hier ein
#   zweites Mal gelesen
#

if typ == 23:

    dateie = open(dateiEin,"r")
    face = 0

    while True:
        line = dateie.readline()

        #   Abbruchbedingung für das Lesen

        if len(line) == 0:
            break
        wert = line.split(" ")

        #   Faces lesen, deren Anzahl und die unmittelbare Nachbarschaft
        #   zweier Vertices feststellen

        if wert[0] == 'f':
            face = face + 1

#           ******************
            for j in range(4):
                wert1[j+1] = wert[j+1].strip()
                wert2[j+1] = wert1[j+1].split("//")
            if len(wert1)>1:
                for k in range(4):
                    wert[k+1] = wert2[k+1][0]
            else:
                 for k in range(4):
                    wert[k+1] = wert2[k+1]
#           ******************

            for i in range(4):
                facefeld[face,(i+1)] = int(wert[(i+1)])
            steuer[face] = 4
            feld[max(facefeld[face,1],facefeld[face,2]),
                 min(facefeld[face,1],facefeld[face,2])] = 1
            feld[max(facefeld[face,2],facefeld[face,3]),
                 min(facefeld[face,2],facefeld[face,3])] = 1
            feld[max(facefeld[face,3],facefeld[face,4]),
                 min(facefeld[face,3],facefeld[face,4])] = 1
            feld[max(facefeld[face,4],facefeld[face,1]),
                 min(facefeld[face,4],facefeld[face,1])] = 1

    dateie.close()


#   Variablenzuweisungen

vertz = vert
facez = face
vert = 1
face = 1

vertfeld = {}

#   Vertices und Faces aus der Einlesedatei lesen,#
#   verfeld[verticenummer, x, y, z]   ,
#   facefeld[facenummer, vertice 1, vertice 2, vertice 3]
#   (falls Typ 24, Dreiecke),
#   facefeld[facenummer, vertice 1, vertice 2, vertice 3, vertice 4]
#   (falls Typ 23, Vierecke),

dateie = open(dateiEin,"r")
while True:
    if typ == 24:
        i = 1
        line = dateie.readline()
        if len(line) == 0:
            break
        wert = line.split(" ")

        if wert[0] == 'v':
            for i in range(3):
                vertfeld[vert,(i+1)] = float(wert[(i+1)])
            vert = vert + 1

        if wert[0] == 'f':
            if len(wert) < 5:

#           ******************
                for j in range(3):
                    wert1[j+1] = wert[j+1].strip()
                    wert2[j+1] = wert1[j+1].split("//")
                if len(wert1)>1:
                    for k in range(3):
                        wert[k+1] = wert2[k+1][0]
                else:
                     for k in range(3):
                        wert[k+1] = wert2[k+1]
#           ******************

                for i in range(3):
                    facefeld[face,(i+1)] = int(wert[(i+1)])
            else:

#           ******************
                for j in range(4):
                    wert1[j+1] = wert[j+1].strip()
                    wert2[j+1] = wert1[j+1].split("//")
                if len(wert1)>1:
                    for k in range(4):
                        wert[k+1] = wert2[k+1][0]
                else:
                     for k in range(4):
                        wert[k+1] = wert2[k+1]
#           ******************

                facefeld[face,1] = int(wert[1])
                facefeld[face,2] = int(wert[2])
                facefeld[face,3] = int(wert[3])
                face = face + 1
                facefeld[face,1] = int(wert[3])
                facefeld[face,2] = int(wert[4])
                facefeld[face,3] = int(wert[1])
            face = face + 1
    else:
        i = 1
        line = dateie.readline()
        if len(line) == 0:
            break
        wert = line.split(" ")

        if wert[0] == 'v':
            for i in range(3):
                vertfeld[vert,(i+1)] = float(wert[(i+1)])
            vert = vert + 1

        if wert[0] == 'f':

#           ******************
            for j in range(4):
                wert1[j+1] = wert[j+1].strip()
                wert2[j+1] = wert1[j+1].split("//")
            if len(wert1)>1:
                for k in range(4):
                    wert[k+1] = wert2[k+1][0]
            else:
                for k in range(4):
                    wert[k+1] = wert2[k+1]
#           ******************

            for i in range(4):
                facefeld[face,(i+1)] = int(wert[(i+1)])
            face = face + 1
dateie.close()

face = face - 1
vert = vert - 1

#
#   Pruefung, ob Vertices vorhanden sind, die nicht mit Faces verbunden sind
#
vertzaehl = {}
for vert1 in range(1,vert+1):
    vertzaehl[vert1] = 0

for face1 in range(1,face+1):
    vertzaehl[facefeld[face1,1]] = 1
    vertzaehl[facefeld[face1,2]] = 1
    vertzaehl[facefeld[face1,3]] = 1
#
#   Hinzugefügt 29.03.2014
#
    if typ == 23:
        vertzaehl[facefeld[face1,4]] = 1
#
#   Ende der Hinzufügung
#

for vert2 in range(1,vert+1):
    if vertzaehl[vert2] < 1:
            fenster = Tk()
            label = [
            Label(fenster, font=('Arial',16),
            text=' Vertices ohne angeschlossene\n'
                 ' Faces vorhanden, bitte korrigieren!', width=40)]
            for l in label: l.pack()
            fenster.mainloop()
            exit()
#
#   Ende der Pruefung !
#

#   Schalenelemente Nr.24 mit 6 Knoten, falls dreickige Faces
#   in der Dateiz88 structure.obj vorhanden sind, sonst
#   Schalenelemente Nr. 24 mit 8 Knoten !

#   Berechnung der neuen Knotenkoordinaten in knokoor
knokoor = {}

#   Die Position des neu geschaffenen Knoten wird durch die
#   Nummern der Nachbarvertices bestimmt
knonum = {}

knoneu = vertz + 1

face = 1

for face in range(1,facez+1):

#       Vertice 1 bis Vertice 3
        for k in range (1,3):
            if feld[max(facefeld[face,k],facefeld[face,(k+1)]),
                     min(facefeld[face,k],facefeld[face,(k+1)])] == 1:

                for i in range(3):
                    knokoor[knoneu,(i+1)] = (
                                    vertfeld[facefeld[face,(k+1)],(i+1)]
                                    + vertfeld[facefeld[face,k],(i+1)])/2.
                knonum[max(facefeld[face,k],facefeld[face,(k+1)]),
                       min(facefeld[face,k],facefeld[face,(k+1)])] = knoneu
                knoneu = knoneu + 1
                feld[max(facefeld[face,k],facefeld[face,(k+1)]),
                         min(facefeld[face,k],facefeld[face,(k+1)])] = 2

#       1.: Dreiecke:

        if typ == 24:
            if feld[max(facefeld[face,3],facefeld[face,1]),
                     min(facefeld[face,3],facefeld[face,1])] == 1:
                for i in range(3):
                    knokoor[knoneu,(i+1)] = (
                                    vertfeld[facefeld[face,1],(i+1)]
                                    + vertfeld[facefeld[face,3],(i+1)])/2.
                knonum[max(facefeld[face,3],facefeld[face,1]),
                       min(facefeld[face,3],facefeld[face,1])] = knoneu
                knoneu = knoneu + 1
                feld[max(facefeld[face,3],facefeld[face,1]),
                        min(facefeld[face,3],facefeld[face,1])] = 2

#       2.: Vierecke

        else:
            if feld[max(facefeld[face,3],facefeld[face,4]),
                     min(facefeld[face,3],facefeld[face,4])] == 1:
                for i in range(3):
                    knokoor[knoneu,(i+1)] = (
                                    vertfeld[facefeld[face,4],(i+1)]
                                    + vertfeld[facefeld[face,3],(i+1)])/2.
                knonum[max(facefeld[face,3],facefeld[face,4]),
                       min(facefeld[face,3],facefeld[face,4])] = knoneu
                knoneu = knoneu + 1
                feld[max(facefeld[face,3],facefeld[face,4]),
                         min(facefeld[face,3],facefeld[face,4])] = 2

            if feld[max(facefeld[face,4],facefeld[face,1]),
                     min(facefeld[face,4],facefeld[face,1])] == 1:
                for i in range(3):
                    knokoor[knoneu,(i+1)] = (
                                    vertfeld[facefeld[face,1],(i+1)]
                                    + vertfeld[facefeld[face,4],(i+1)])/2.
                knonum[max(facefeld[face,4],facefeld[face,1]),
                       min(facefeld[face,4],facefeld[face,1])] = knoneu
                knoneu = knoneu + 1
                feld[max(facefeld[face,4],facefeld[face,1]),
                         min(facefeld[face,4],facefeld[face,1])] = 2






#   Schreiben der Datei "z88structure.txt"

knoges = knoneu - 1

dateia = open(dateiAus,"w")
dateia.write(' 3 '+str(knoges)+' '+str(facez)+' '+str(6*knoges)+' 0 #AURORA_V2'+'\n')

i = 1
for i in range (vertz):
    dateia.write(str(i+1)+' 6 '+str(vertfeld[(i+1),1])+' '+str((-1)*(vertfeld[(i+1),3]))
                 +' '+str(vertfeld[(i+1),2])+'\n')

for i in range (vertz,knoges):

    dateia.write(str(i+1)+' 6 '+str(knokoor[(i+1),1])+' '+str((-1)*(knokoor[(i+1),3]))
                 +' '+str(knokoor[(i+1),2])+'\n')

for face in range(1,facez+1):
    if typ == 24:
        dateia.write(str(face)+'  24\n    '+str(facefeld[face,1])+' '
                      +str(facefeld[face,2])+' '+str(facefeld[face,3])+' '
                      +str( knonum[max(facefeld[face,1],facefeld[face,2]),
                                   min(facefeld[face,1],facefeld[face,2])] )+' '
                      +str( knonum[max(facefeld[face,2],facefeld[face,3]),
                                   min(facefeld[face,2],facefeld[face,3])] )+' '
                      +str( knonum[max(facefeld[face,3],facefeld[face,1]),
                                   min(facefeld[face,3],facefeld[face,1])] )+'\n')
    else:
        dateia.write(str(face)+'  23\n    '+str(facefeld[face,1])+' '
                      +str(facefeld[face,2])+' '+str(facefeld[face,3])+' '
                      +str(facefeld[face,4])+' '
                      +str( knonum[max(facefeld[face,1],facefeld[face,2]),
                                   min(facefeld[face,1],facefeld[face,2])] )+' '
                      +str( knonum[max(facefeld[face,2],facefeld[face,3]),
                                   min(facefeld[face,2],facefeld[face,3])] )+' '
                      +str( knonum[max(facefeld[face,3],facefeld[face,4]),
                                   min(facefeld[face,3],facefeld[face,4])] )+' '
                      +str( knonum[max(facefeld[face,4],facefeld[face,1]),
                                   min(facefeld[face,4],facefeld[face,1])] )+'\n')

dateia.write('  1  '+str(facez)+'  200000.0    0.3   3    3')
dateia.close()
