﻿# Autor:   Christian Claus
# Datum:   31. Januar 2014
#
#   Datei z88structure.txt in eine Datei z88structure-aus.obj umwandeln
#   Die in Z88 berechneten Knotenverschiebungen werden aus der Datei
#   z88o2.txt eingelesen

from math import *
from tkinter import *

#
#   Zeiterfassung
#
from time import *
lt = localtime()
jahr, monat, tag, stunde, minute, sekunde = lt[0:6]
tag1 = str(tag).strip()
stunde1 = str(stunde).strip()
minute1 = str(minute).strip()
sekunde1 = str(sekunde).strip()
if int(tag1) < 10:
    tag1 = '0'+ tag1
if int(stunde1) < 10:
    stunde1 = '0'+ stunde1
if int(minute1) < 10:
    minute1 = '0'+ minute1
if int(sekunde1) < 10:
    sekunde1 = '0'+ sekunde1
if monat == 1:
    monat1 = 'Januar'
elif monat == 2:
    monat1 = 'Februar'
elif monat == 3:
    monat1 = 'Maerz'
elif monat == 4:
    monat1 = 'April'
elif monat == 5:
    monat1 = 'Mai'
elif monat == 6:
    monat1 = 'Juni'
elif monat == 7:
    monat1 = 'Juli'
elif monat == 8:
    monat1 = 'August'
elif monat == 9:
    monat1 = 'September'
elif monat == 10:
    monat1 = 'Oktober'
elif monat == 11:
    monat1 = 'November'
else:
    monat1 = 'Dezember'

li1 = {}
li2 = {}
nrk = {}
x = {}
y = {}
z = {}
nre = {}
kno1 = {}
kno2 = {}
kno3 = {}
kno4 = {}
typ = 24

#
#   Datei z88structure.txt einlesen
#

z88structure = "z88structure.txt"

try:
    dateie1 = open(z88structure,"r")

    line1 = dateie1.readline()
    lin1 = line1.strip()
    li1 = lin1.split(" ")

#       Einlesen der Knotenkoordinaten

    for i in range (1,(int(li1[1])+1)):
        line2 = dateie1.readline()
        lin2 = line2.strip()
        li2 = lin2.split(" ")
        nrk[i] = int(li2[0])
        x[i] = float(li2[2])
        y[i] = float(li2[3])
        z[i] = float(li2[4])        

#       Einlesen der Elemente

    for j in range (1,(int(li1[2])+1)):
        line31 = dateie1.readline()
        lin31 = line31.strip()
        li31 = lin31.split(" ")
        nre[j] = int(li31[0])
        typ = int(li31[2])
        line32 = dateie1.readline()
        lin32 = line32.strip()
        li32 = lin32.split(" ") 
        kno1[j] = int(li32[0])
        kno2[j] = int(li32[1])
        kno3[j] = int(li32[2])
        if  typ == 23:
            kno4[j] = int(int(li32[3]))
                          
    dateie1.close()

except:
    fenster = Tk()
    label = [
    Label(fenster, font=('Arial',16),
    text=' Einlesen der Datei "z88structure.txt" klappt nicht ! ', width=40)]
    for l in label: l.pack()
    fenster.mainloop()
    exit()
    

#       Einlesen der Verformungen aus Datei "z88o2.txt"

nrk1 = {}
deltax = {}
deltay = {}
deltaz = {}

z88o2 = "z88o2.txt"

try:
    dateie2 = open(z88o2,"r")
    
    for k in range (5):
        line = dateie2.readline()


    for m in range (1,(int(li1[1])+1)):
        line4 = dateie2.readline()
        lin4 = line4.strip()
        li4 = lin4.split(" ")
        nrk1[m] = int(li4[0])
        deltax[m] = float(li4[3])
        deltay[m] = float(li4[6])
        deltaz[m] = float(li4[9])     


    dateie2.close()

except:
    fenster = Tk()
    label = [
    Label(fenster, font=('Arial',16),
    text=' Einlesen der Datei "z88o2.txt" klappt nicht ! ', width=40)]
    for l in label: l.pack()
    fenster.mainloop()
    exit()


steuer = {}
for n in range (1,(int(li1[1])+1)):
    steuer[n] = 0

for n in range (1,(int(li1[1])+1)):
    for o in range (1,(int(li1[2])+1)):    
        if kno1[o] == n:
            steuer[n] = 1
        elif kno2[o] == n:
            steuer[n] = 1   
        elif kno3[o] == n:
            steuer[n] = 1


#
#   Skalierungsfaktor der Verformungen
#

while True:
    try:
        scal = input(' Bitte den Skalierungsfaktor,\n'
                     ' fuer die Verformungen eingeben !')
        scale = int(scal)
        break
    except:
        print('Falsche Eingabe')


#
#   Verknuepfung der Knotenpositionen mit den Verformungen
#
for n in range (1,(int(li1[1])+1)):
    if steuer[n] == 1:
        x[n] = x[n] + ( scale * deltax[n] )
        y[n] = y[n] + ( scale * deltay[n] )
        z[n] = z[n] + ( scale * deltaz[n] )

#
#   Ausgabedatei z88structure-aus.obj erzeugen und herausschreiben
#

CdbAus = "z88structure-aus.obj"

dateia = open(CdbAus,"w")

dateia.write('#   z88structure-aus.obj zum Einlesen von Verformungsergebnissen aus Z88 '+'\n'
            +'#   '+tag1+'. '+monat1+' '+str(jahr)+'   '+stunde1+':'
            +minute1+':'+sekunde1+'\n'+'!!'+'\n'
            +'mtllib z88structure-aus.mtl'+'\n'+'o Beliebiger Name'+'\n')

for i in range (1,(int(li1[1])+1)):
    if steuer[i] == 1:
        dateia.write('v '+str(x[i])+' '+str(z[i])+' '+str(((-1)*y[i]))+'\n')

dateia.write('usemtl Material'+'\n'+'s off'+'\n')

for i in range (1,(int(li1[2])+1)):
        if typ == 23:
            dateia.write('f '+str(kno1[i])+' '+str(kno2[i])
                         +' '+str(kno3[i])+' '+str(kno4[i])+'\n')
        else:
            dateia.write('f '+str(kno1[i])+' '+str(kno2[i])
                         +' '+str(kno3[i])+'\n')                          

dateia.close()
          



    
